/*******************************************************************\

              Copyright (C) 2003 Joseph Coffland

    This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
             GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
      Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
                           02111-1307, USA.

            For information regarding this software email
                   jcofflan@users.sourceforge.net

\*******************************************************************/

#include "XMLParseEvent.h"

#include <BasicUtils/BasicException.h>

#include <xercesc/sax/Locator.hpp>

using namespace std;
XERCES_CPP_NAMESPACE_USE;

XMLParseEvent::XMLParseEvent(XMLPullParser::event_t event,
			     const Locator *locator) :
  event(event), numAttribs(0), attribs(NULL), isWhitespace(false) {
  if (locator) {
    line = locator->getLineNumber();
    col = locator->getColumnNumber();

  } else {
    line = -1;
    col = -1;
  }
}

XMLParseEvent::~XMLParseEvent() {
  if (attribs) delete[] attribs;
}


const string &XMLParseEvent::getEventName(XMLPullParser::event_t event) {
  static string eventNames[] = {
    "NULL_EVENT", "START_DOCUMENT", "START_ELEMENT", "TEXT",
    "END_ELEMENT", "END_DOCUMENT", "PROCESSING_INSTRUCTION"
  };

  int i;
  XMLPullParser::event_t tmp = event & XMLPullParser::ANY_EVENT;
  for (i = 0; tmp; i++) tmp = tmp >> 1;

  return eventNames[i];
}
